package com.cristobalbernal.foro.controlador;

import com.cristobalbernal.foro.Entidades.CategoriaForoEntity;
import com.cristobalbernal.foro.Entidades.Foro;
import com.cristobalbernal.foro.Entidades.RespuestasEntity;
import com.cristobalbernal.foro.Entidades.UsersEntity;
import com.cristobalbernal.foro.Respositorios.IUsers;
import com.cristobalbernal.foro.Servicios.ServicioCategoria;
import com.cristobalbernal.foro.Servicios.ServicioForo;
import com.cristobalbernal.foro.Servicios.ServicioRespuestas;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.List;

@RequestMapping("/api")
@Controller
public class ControladorAPI {
    @Autowired
    private IUsers iUsers;
    @Autowired
    private ServicioRespuestas servicioRespuestas;
    @Autowired
    private ServicioCategoria servicioCategoria;
    @Autowired
    private ServicioForo servicioForo;


    @GetMapping("/users")
    public @ResponseBody List<UsersEntity> getAllUsers(){
        return iUsers.findAll();
    }
    @GetMapping("/respuestas")
    public @ResponseBody List<RespuestasEntity> getAllRespuestas(){
        return servicioRespuestas.findAll();
    }
    @GetMapping("/categorias")
    public @ResponseBody List<CategoriaForoEntity> getAllCategorias(){
        return servicioCategoria.findAll();
    }
    @GetMapping("/foro")
    public @ResponseBody List<Foro> getAllForo(){
        return servicioForo.init();
    }


}
